#ifndef _CTYPE_H_
#define _CTYPE_H_

#if 1

#ifdef __cplusplus
extern "C" 
{
#endif

extern int isdigit(int c);
extern int isalnum(int c);
extern int isalpha(int c);
extern int isascii(int c);
extern int isblank(int c);
extern int iscntrl(int c);
extern int isgraph(int c);
extern int islower(int c);
extern int isprint(int c);
extern int ispunct(int c);
extern int isspace(int c);
extern int isupper(int c);
extern int isxdigit(int c);

extern int toupper(int c);
extern int tolower(int c);

#ifdef __cplusplus
}
#endif


#else

extern unsigned long	ctype_table[];

inline int isdigit(int c) { return  ctype_table[c] & 0x20; }
inline int isalnum(int c) { return  ctype_table[c] & 0x01; }
inline int isalpha(int c) { return  ctype_table[c] & 0x02; }
inline int isascii(int c) { return  ctype_table[c] & 0x04; }
inline int isblank(int c) { return  ctype_table[c] & 0x08; }
inline int iscntrl(int c) { return  ctype_table[c] & 0x10; }
inline int isgraph(int c) { return  ctype_table[c] & 0x40; }
inline int islower(int c) { return  ctype_table[c] & 0x80; }
inline int isprint(int c) { return  ctype_table[c] & 0x100; }
inline int ispunct(int c) { return  ctype_table[c] & 0x200; }
inline int isspace(int c) { return  ctype_table[c] & 0x400; }
inline int isupper(int c) { return  ctype_table[c] & 0x800; }
inline int isxdigit(int c) { return  ctype_table[c] & 0x1000; }

inline int toupper(int c) { return islower(c) ? c + 0x20 : c; }
inline int tolower(int c) { return isupper(c) ? c - 0x20 : c; }

#endif

#endif
