#ifndef _IOPORTS_H
#define _IOPORTS_H

extern inline unsigned char inb(unsigned int port)
{
    unsigned char  tmp;

    if (port < 0x100) /* GCC can optimize this if constant */
	__asm__ __volatile__ ("inb %w1, %0" :"=al"(tmp) :"dN"(port));
    else
	__asm__ __volatile__ ("inb %%dx, %0" :"=al"(tmp) :"d"(port));

    return tmp;
}

extern inline void outb(unsigned int port, unsigned char val)
{
    if (port < 0x100) /* GCC can optimize this if constant */
	__asm__ __volatile__ ("outb %1, %w0" : :"dN"(port), "al"(val));
    else
	__asm__ __volatile__ ("outb %1, %%dx" : :"d"(port), "al"(val));
}

extern inline unsigned short inw(unsigned int port)
{
    unsigned short  tmp;

    if (port < 0x100) /* GCC can optimize this if constant */
	__asm__ __volatile__ ("inw %w1, %0" :"=ax"(tmp) :"dN"(port));
    else
	__asm__ __volatile__ ("inw %%dx, %0" :"=ax"(tmp) :"d"(port));

    return tmp;
}

extern inline void outw(unsigned int port, unsigned short val)
{
    if (port < 0x100) /* GCC can optimize this if constant */
	__asm__ __volatile__ ("outw %1, %w0" : :"dN"(port), "ax"(val));
    else 
	__asm__ __volatile__ ("outw %1, %%dx" : :"d"(port), "ax"(val));
}

extern inline unsigned long inl(unsigned int port)
{
    unsigned long  tmp;

    if (port < 0x100) /* GCC can optimize this if constant */
	__asm__ __volatile__ ("inl %w1, %0" :"=eax"(tmp) :"dN"(port));
    else
	__asm__ __volatile__ ("inl %%dx, %0" :"=eax"(tmp) :"d"(port));

    return tmp;
}

extern inline void outl(unsigned int port, unsigned long val)
{
    if (port < 0x100) /* GCC can optimize this if constant */
	__asm__ __volatile__ ("outl %1, %w0" : :"dN"(port), "eax"(val));
    else 
	__asm__ __volatile__ ("outl %1, %%dx" : :"d"(port), "eax"(val));
}

#endif
