#ifndef _DEVICE_H_
#define _DEVICE_H_

#include <l4/types.h>

typedef enum
{
	category_RawDeviceDriver,
	category_StreamDeviceDriver,
	category_BlockDeviceDriver,
	category_ProtocolService
} typeDriverCategory;

typedef enum
{
	drivermodel_Module,
	drivermodel_Process,
	drivermodel_Thread
} typeDriverModel;

typedef struct 
{
	unsigned int			Major;				// Major device number
	unsigned int			Minor;				// Minor device number
	unsigned int			MinorCount;			// Count of minor devices
	typeDriverCategory		Category;			// Describes driver type: device or protocol
	typeDriverModel			Model;				// Kernel module or standalone process
	unsigned char			DeviceName[16];		// Device name (not null terminated)
} PublicDeviceRecord_t;

extern bool EnumerateDevice(
	int							nRecordNumber,
	PublicDeviceRecord_t	*	pRecord);
	
#endif
